<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "communication_event".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "CommunicationEvent".
 *
 * Columns in table "communication_event" available as properties of the model,
 * and there are no model relations.
 *
 * @property integer $id
 * @property integer $communication_log_id
 * @property integer $opens
 * @property integer $clicks
 * @property string $date_added
 * @property string $date_updated
 * @property string $status
 * @property string $communication_uid
 * @property string $subject
 * @property string $email
 * @property string $tags
 * @property string $sender
 * @property string $template
 * @property string $smtp_events
 * @property string $resends
 * @property string $opens_detail
 * @property string $clicks_detail
 *
 */
abstract class BaseCommunicationEvent extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'communication_event';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'CommunicationEvent|CommunicationEvents', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('communication_log_id, opens, clicks', 'numerical', 'integerOnly' => true),
            array('status', 'length', 'max' => 50),
            array('communication_uid, subject, email, tags, sender, template', 'length', 'max' => 255),
            array('date_added, date_updated, smtp_events, resends, opens_detail, clicks_detail', 'safe'),
            array('communication_log_id, opens, clicks, date_added, date_updated, status, communication_uid, subject, email, tags, sender, template, smtp_events, resends, opens_detail, clicks_detail', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, communication_log_id, opens, clicks, date_added, date_updated, status, communication_uid, subject, email, tags, sender, template, smtp_events, resends, opens_detail, clicks_detail', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'communication_log_id' => Yii::t('app', 'Communication Log'),
            'opens' => Yii::t('app', 'Opens'),
            'clicks' => Yii::t('app', 'Clicks'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'status' => Yii::t('app', 'Status'),
            'communication_uid' => Yii::t('app', 'Communication Uid'),
            'subject' => Yii::t('app', 'Subject'),
            'email' => Yii::t('app', 'Email'),
            'tags' => Yii::t('app', 'Tags'),
            'sender' => Yii::t('app', 'Sender'),
            'template' => Yii::t('app', 'Template'),
            'smtp_events' => Yii::t('app', 'Smtp Events'),
            'resends' => Yii::t('app', 'Resends'),
            'opens_detail' => Yii::t('app', 'Opens Detail'),
            'clicks_detail' => Yii::t('app', 'Clicks Detail'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('communication_log_id', $this->communication_log_id);
        $criteria->compare('opens', $this->opens);
        $criteria->compare('clicks', $this->clicks);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('status', $this->status, true);
        $criteria->compare('communication_uid', $this->communication_uid, true);
        $criteria->compare('subject', $this->subject, true);
        $criteria->compare('email', $this->email, true);
        $criteria->compare('tags', $this->tags, true);
        $criteria->compare('sender', $this->sender, true);
        $criteria->compare('template', $this->template, true);
        $criteria->compare('smtp_events', $this->smtp_events, true);
        $criteria->compare('resends', $this->resends, true);
        $criteria->compare('opens_detail', $this->opens_detail, true);
        $criteria->compare('clicks_detail', $this->clicks_detail, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
